const K = require('kcore');

K.NateAbstract = class K_NateAbstract
{
  _init()
  {
    this.children = [];
  }

  constructor(parent)
  {
    this._init();
  }

  delete()
  {
    // # TODO: implement this, but at the moment we need it only in K.NateXxxDom.
  }

  newNate(elem = null)
  {
    // Should be implemented in derived class.
    K.Error.throwNotImplementedError('K.NateAbstract::newNate');
  }

  push(child)
  {
    this.children.push(child);
  }

  render()
  {
    let txt = '';

    for (let id in this.children)
    {
      txt += this.children[id].render();
    }

    return txt;
  }
};
